<template>
    <div style="display: flex">
        <div ref="eChart" style="height: 340px;width: 700px; margin: 0px 40px"></div>
    </div>
</template>

<script>
import {
    listDeviceLogCount,
} from '@/api/iot/alertLog';
import { getNettyMqttStats } from '@/api/iot/netty';
import 'echarts-gl';

export default {
    data() {
        return {
            // emqx统计信息
            static: {},
            timer: null,
            mqtt: this.$store.state.user.mqtt,
            xDatas: [],
            yDatas: [],
        };
    },
    created() {

    },
    mounted() {
        this.statisticMqtt();
    },
    computed: {},
    beforeDestroy() {
        this.clearData();
    },
    methods: {
        /** 查询emqx统计*/
        statisticMqtt() {
            this.xDatas = [];
            this.yDatas = [];
            listDeviceLogCount().then((response) => {
                response.data.forEach(item => {
                    if (item.status === 1) {
                        this.xDatas.push('不需要处理');
                        this.yDatas.push(item.count1);
                    }
                    else if (item.status === 2) {
                        this.xDatas.push('未处理');
                        this.yDatas.push(item.count1);
                    } else {
                        this.xDatas.push("已处理");
                        this.yDatas.push(item.count1);
                    }
                });
                this.drawLine();
            });

        },
        drawLine() {

            if (this.mqtt) {
                getNettyMqttStats().then((response) => {
                    this.stats = response.data;
                    this.drawStats();
                    // 轮询
                    this.switper();
                });
            } else {
                this.$nextTick(() => {
                    // 初始值
                    this.stats = {
                        'connections.count': 800,
                        'connections.max': 8000,
                        'sessions.count': 700,
                        'sessions.max': 7000,
                        'topics.count': 600,
                        'topics.max': 6000,
                        'subscribers.count': 500,
                        'subscribers.max': 5000,
                        'routes.count': 400,
                        'routes.max': 4000,
                        'retained.count': 300,
                        'retained.max': 3000,
                    };
                    this.drawStats();
                    // 轮询
                    this.switper();
                });
            }
        },
        /** EMQX状态统计 */
        drawStats() {
            // 基于准备好的dom，初始化echarts实例
            let myChart = this.$echarts.init(this.$refs.eChart);
            var option;
            let colors = ['#0C82E6', 'rgb(43,178,219)', '#5AC3FF']
            let xData = this.xDatas
            let yData = this.yDatas
            // 传入数据生成 option
            let optionsData = [];
            for (let i = 0; i < xData.length; i++) {
                optionsData.push(
                    {
                        name: xData[i],
                        value: yData[i],
                        itemStyle: {
                            color: colors[i],
                        }
                    }
                );
            }

            const series = this.getPie3D(optionsData, 0.8, 240, 28, 26, 0.5);
            option = {
                legend: {
                    tooltip: {
                        show: true,
                    },
                    data: xData,
                    top: '5%',
                    icon: 'circle',
                    textStyle: {
                        color: '#fff',
                        fontSize: 14,
                    }
                },
                animation: true,
                tooltip: {
                    formatter: params => {
                        if (params.seriesName !== 'mouseoutSeries' && params.seriesName !== 'pie2d') {
                            return `${params.seriesName}<br/><span style="display:inline-block;margin-right:5px;border-radius:10px;width:10px;height:10px;background-color:${params.color};"></span>${option.series[params.seriesIndex].pieData.value}`;
                        }
                    },
                    textStyle: {
                        fontSize: 12
                    },
                },
                title: {
                    x: 'center',
                    top: '20',
                    textStyle: {
                        color: '#fff',
                        fontSize: 12,
                    },
                },
                labelLine: {
                    show: true,
                    lineStyle: {
                        color: 'transparent',
                    },
                },
                label: {
                    color: 'transparent',
                    position: 'outside',
                    formatter: '{b} \n{c} {d}%',
                },
                xAxis3D: {
                    min: -1,
                    max: 1,
                },
                yAxis3D: {
                    min: -1,
                    max: 1,
                },
                zAxis3D: {
                    min: -1,
                    max: 1,
                },
                grid3D: {
                    show: false,
                    boxHeight: 0.5,
                    bottom: '60%',
                    viewControl: {
                        distance: 280,//敏感度
                        alpha: 20,//视角
                        autoRotate: true, // 自动旋转
                    },
                },
                series: series,
            };
            myChart.setOption(option);
        },
        getParametricEquation(startRatio, endRatio, isSelected, isHovered, k, height) {
            let heightProportion = 10;

            // 计算
            let midRatio = (startRatio + endRatio) / 3;

            let startRadian = startRatio * Math.PI * 2;
            let endRadian = endRatio * Math.PI * 2;
            let midRadian = midRatio * Math.PI * 2;

            // 如果只有一个扇形，则不实现选中效果。
            if (startRatio === 0 && endRatio === 1) {
                isSelected = false;
            }

            // 通过扇形内径/外径的值，换算出辅助参数 k（默认值 1/3）
            k = typeof k !== 'undefined' ? k : 1 / 3;

            // 计算选中效果分别在 x 轴、y 轴方向上的位移（未选中，则位移均为 0）
            let offsetX = isSelected ? Math.cos(midRadian) * 0.1 : 0;
            let offsetY = isSelected ? Math.sin(midRadian) * 0.1 : 0;

            // 计算高亮效果的放大比例（未高亮，则比例为 1）
            let hoverRate = isHovered ? 1.1 : 1;

            // 返回曲面参数方程
            return {
                u: {
                    min: -Math.PI,
                    max: Math.PI * 3,
                    step: Math.PI / 32
                },

                v: {
                    min: 0,
                    max: Math.PI * 2,
                    step: Math.PI / 20
                },

                x: function (u, v) {
                    if (u < startRadian) {
                        return offsetX + Math.cos(startRadian) * (1 + Math.cos(v) * k) * hoverRate;
                    }
                    if (u > endRadian) {
                        return offsetX + Math.cos(endRadian) * (1 + Math.cos(v) * k) * hoverRate;
                    }
                    return offsetX + Math.cos(u) * (1 + Math.cos(v) * k) * hoverRate;
                },

                y: function (u, v) {
                    if (u < startRadian) {
                        return offsetY + Math.sin(startRadian) * (1 + Math.cos(v) * k) * hoverRate;
                    }
                    if (u > endRadian) {
                        return offsetY + Math.sin(endRadian) * (1 + Math.cos(v) * k) * hoverRate;
                    }
                    return offsetY + Math.sin(u) * (1 + Math.cos(v) * k) * hoverRate;
                },

                z: function (u, v) {
                    if (u < -Math.PI * 0.5) {
                        return Math.sin(u);
                    }
                    if (u > Math.PI * 2.5) {
                        return Math.sin(u);
                    }
                    console.log(height, "height")
                    return Math.sin(v) > 0 ? heightProportion * height : -1;
                }
            };
        },
        // 生成模拟 3D 饼图的配置项
        getPie3D(pieData, internalDiameterRatio) {

            let series = [];
            let sumValue = 0;
            let startValue = 0;
            let endValue = 0;
            let legendData = [];
            let linesSeries = []; // line3D模拟label指示线
            let k = typeof internalDiameterRatio !== 'undefined' ? (1 - internalDiameterRatio) / (1 + internalDiameterRatio) : 1 / 3;

            // 为每一个饼图数据，生成一个 series-surface 配置
            for (let i = 0; i < pieData.length; i++) {

                sumValue += pieData[i].value;

                let seriesItem = {
                    name: typeof pieData[i].name === 'undefined' ? `series${i}` : pieData[i].name,
                    type: 'surface',
                    parametric: true,
                    wireframe: {
                        show: false
                    },
                    pieData: pieData[i],
                    pieStatus: {
                        selected: false,
                        hovered: false,
                        k: k
                    }
                };

                if (typeof pieData[i].itemStyle != 'undefined') {

                    let itemStyle = {};

                    typeof pieData[i].itemStyle.color != 'undefined' ? itemStyle.color = pieData[i].itemStyle.color : null;
                    typeof pieData[i].itemStyle.opacity != 'undefined' ? itemStyle.opacity = pieData[i].itemStyle.opacity : null;

                    seriesItem.itemStyle = itemStyle;
                }
                series.push(seriesItem);
            }

            // 使用上一次遍历时，计算出的数据和 sumValue，调用 getParametricEquation 函数，
            // 向每个 series-surface 传入不同的参数方程 series-surface.parametricEquation，也就是实现每一个扇形。
            for (let i = 0; i < series.length; i++) {
                endValue = startValue + series[i].pieData.value;
                series[i].pieData.startRatio = startValue / sumValue;
                series[i].pieData.endRatio = endValue / sumValue;
                series[i].parametricEquation = this.getParametricEquation(series[i].pieData.startRatio,
                    series[i].pieData.endRatio,
                    false,
                    false,
                    k,
                    series[i].pieData.value
                );

                startValue = endValue;
                legendData.push(series[i].name);
            }
            series = series.concat(linesSeries)

            // 最底下圆盘
            series.push({
                name: 'mouseoutSeries',
                type: 'surface',
                parametric: true,
                wireframe: {
                    show: false,
                },
                itemStyle: {
                    opacity: 1,
                    color: 'rgba(25, 93, 176, 1)',
                },
                parametricEquation: {
                    u: {
                        min: 0,
                        max: Math.PI * 2,
                        step: Math.PI / 20,
                    },
                    v: {
                        min: 0,
                        max: Math.PI,
                        step: Math.PI / 20,
                    },
                    x: function (u, v) {
                        return ((Math.sin(v) * Math.sin(u) + Math.sin(u)) / Math.PI) * 2;
                    },
                    y: function (u, v) {
                        return ((Math.sin(v) * Math.cos(u) + Math.cos(u)) / Math.PI) * 2;
                    },
                    z: function (u, v) {
                        return Math.cos(v) > 0 ? -0 : -1.5;
                    },
                },
            });
            return series;
        },
        clearData() {
            if (this.timer) {
                clearInterval(this.timer);
                this.timer = null;
            }
        },
        //轮询
        switper() {
            if (this.timer) {
                return;
            }
            let looper = (a) => {
                this.statisticMqtt();
            };
            this.timer = setInterval(looper, 60000);
        },
    },
};
</script>
